import * as server from "@minecraft/server"
import { world, system, EquipmentSlot, ItemStack, Player, EntityComponentTypes, EffectTypes } from '@minecraft/server';

system.runInterval(() => {

    world.getAllPlayers().forEach(entity => {
        const equipment = entity.getComponent(EntityComponentTypes.Equippable)
        const headItem = equipment.getEquipmentSlot(EquipmentSlot.Head)
        if (headItem.hasItem() && headItem.typeId === "plains:garland") {

            const health = entity.getComponent("health")


            if (health.currentValue < health.effectiveMax) {
                health.setCurrentValue(health.currentValue + 1)
                const garland = headItem.getItem()

                let damagedItem = damageItem(garland)
                equipment.setEquipment(EquipmentSlot.Head, damagedItem)
            }
        }
    })
}, 7 * server.TicksPerSecond
)

function damageItem(item, itemDamage) {

    const damage = Number(itemDamage) || Math.random()

    const durabilityComponent = item.getComponent("durability")
    var unbreaking = 0
    if (item.hasComponent("enchantments")) {
        unbreaking = item.getComponent("enchantments").enchantments.getEnchantment("unbreaking")
        if (!unbreaking) {
            unbreaking = 0
        } else {
            unbreaking = unbreaking.level
        }
    }
    if (durabilityComponent.damage == durabilityComponent.maxDurability) {

        return
    }
    durabilityComponent.damage += Number(Math.round(damage * 100) <= durabilityComponent.getDamageChance(unbreaking))
    return item
}
world.afterEvents.entityHurt.subscribe(event => {

    const sourse = event.damageSource.damagingProjectile
    if (!sourse) return

    const hurtEntity = event.hurtEntity
    const equipment = hurtEntity.getComponent(EntityComponentTypes.Equippable)

    if (!equipment) return

    const legsItem = equipment.getEquipmentSlot(EquipmentSlot.Legs)
    if (legsItem.hasItem() && legsItem.typeId === "plains:bustard_tail") {


        if (sourse.typeId === "minecraft:arrow") {

            hurtEntity.addEffect('speed', 5 * server.TicksPerSecond, { amplifier: 1, showParticles: false })


        }
    }

})


